/* ArduinoBlocks.com */
/* Project: MEDIDOR DE ALTURA_bueno3 */
/* Author: Rafa Mor */

#include <Wire.h>
#include "ABlocks_LiquidCrystal_I2C.h"

double ALTURA;

LiquidCrystal_I2C lcd(0x27,16,2);

double fnc_ultrasonic_distance(int _t, int _e, int _maxdistance){
	double dur=0;
	digitalWrite(_t, LOW);
	delayMicroseconds(2);
	digitalWrite(_t, HIGH);
	delayMicroseconds(10);
	digitalWrite(_t, LOW);
	unsigned int maxEchoTime=min(_maxdistance, 400) * 29.2 * 2;
	dur = pulseIn(_e, HIGH, maxEchoTime);
	return (dur/(29.2 * 2.0));
}

// BLOQUE SUBRUTINA PARA ANIMACIÓN DE MEDIDA
void MEDIDA() {
  for (int count = 0; count < 5; count++) {
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print(String("MIDIENDO."));
    delay(300);
    lcd.setCursor(2, 0);
    lcd.print(String("MIDIENDO.."));
    delay(300);
    lcd.setCursor(2, 0);
    lcd.print(String("MIDIENDO..."));
    delay(300);
  }
}

void setup()
{
  pinMode(8, OUTPUT);
pinMode(11, OUTPUT);
pinMode(9, OUTPUT);
pinMode(10, INPUT);
pinMode(13, OUTPUT);
lcd.begin();lcd.noCursor();lcd.backlight();
Serial.begin(9600);

  // MEDIDOR DE ALTURA ALIMENTACIÓN SENSOR: 8 Y 11 SITUAR SENSOR A UNA ALTURA DE 2M
  digitalWrite(8, HIGH);
  digitalWrite(11, LOW);
  ALTURA = fnc_ultrasonic_distance(9,10,400);
  digitalWrite(13, LOW);
  for (int count = 0; count < 10; count++) {
    lcd.noBacklight();
    delay(100);
    lcd.backlight();
    delay(100);
  }
  lcd.setCursor(0, 0);
  lcd.print(String("MEDIDA DE ALTURA"));
  lcd.setCursor(0, 1);
  lcd.print(String("  GRATUITO  :)"));
  delay(3000);

}


void loop()
{

    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print(String("SITUE LOS PIES Y"));
    lcd.setCursor(0, 1);
    lcd.print(String("  NO SE MUEVA"));
    delay(3000);
    MEDIDA();
    ALTURA = fnc_ultrasonic_distance(9,10,400);
    Serial.println(fnc_ultrasonic_distance(9,10,400));
    delay(100);
    // ALTURA COMO DIFERENCIA ENTRE 2M Y LA DISTANCIA MEDIDA POR EL SENSOR
    lcd.setCursor(4, 1);
    lcd.print(((200 - ALTURA)));
    lcd.setCursor(10, 1);
    lcd.print(String("CM"));
    delay(5000);

}